<!DOCTYPE html>
<html>
    <head>
        <title></title>
        <style>
canvas { background-color: black; }
        </style>
    </head>
    <body>

        <canvas id='game' width='800' height='600' />

        <!-- howler.js -->
        <script src="https://cdnjs.cloudflare.com/ajax/libs/howler/2.2.3/howler.min.js" integrity="sha512-6+YN/9o9BWrk6wSfGxQGpt3EUK6XeHi6yeHV+TYD2GR0Sj/cggRpXr1BrAQf0as6XslxomMUxXp2vIl+fv0QRA==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>

        <script>

const SCREEN_WIDTH = 800;
const SCREEN_HEIGHT = 600;


function loadImage(src) {
    return new Promise((resolve, reject) => {
        let img = new Image();
        img.addEventListener('load', () => resolve(img));
        img.addEventListener('error', reject);
        img.src = src;
    });
}

const KEY_UP = 0;
const KEY_RIGHT = 1;
const KEY_DOWN = 2;
const KEY_LEFT = 3;
const KEY_SPACE = 4;

const SPACE_FRICTION = 0.9;

const KEYS = [
    'ArrowUp',
    'ArrowRight',
    'ArrowDown',
    'ArrowLeft',
    ' '
];

const keyState = [false, false, false, false, false];

function handleKey(key, isDown) {
    let k = KEYS.indexOf(key);
    if (k >= 0) {
        keyState[k] = isDown;
    }
}


let ctx;

const sprites = {};

class GameObject {

    constructor(game, x, y, w, h, vx, vy, spr) {
        this.game = game;
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        this.vx = vx;
        this.vy = vy;
        this.spr = spr;
        this.friction = 1;
        this.remove = false;
        this.facing = 1; // 1 = downward, -1 = upward
        this.removeIfOffscreen = true;
    }

    draw() {
        ctx.drawImage(this.spr, this.x, this.y);
    }

    tick() {

        this.x += this.vx;
        this.y += this.vy;

        if (this.removeIfOffscreen && this.offscreen())
            this.remove = true;

        // Space friction (?)
        this.vx = this.vx * this.friction;
        this.vy = this.vy * this.friction;
    }

    offscreen() {
        return this.x < -this.w || this.x > SCREEN_WIDTH || this.y < -this.h || this.y > SCREEN_HEIGHT;
    }

    collidesWith(obj) {
        // Rectangles do not overlap if one is to the side of or above the other
        if (this.x > obj.x + obj.w || obj.x > this.x + this.w ||
            this.y > obj.y + obj.h || obj.y > this.y + this.h) {

            return false;
        }
        return true;
    }
}

class Bullet extends GameObject {
    constructor(owner, x, y, vx, vy) {
        super(owner.game, x, y, 5, 6, vx, vy, sprites['bullet']);
        this.owner = owner;
        this.isPlayerBullet = owner instanceof Player;
    }

    tick() {
        super.tick();

        if (this.isPlayerBullet) {
            this.game.enemies
                .filter(e => e.collidesWith(this))
                .forEach(e => {
                    console.log('Boom! Killed enemy');
                    e.remove = true;
                });
        } else if (this.game.player && this.game.player.collidesWith(this)) {
            console.log(`Sorry, you're dead!`);
            this.game.player.remove = true;
            this.game.player = undefined;
        }
    }
}

class PeaShooter {
    constructor(owner) {
        this.owner = owner;
        this.framesPerBullet = 6;
        this.numberOfBullets = 2;      // bullets shot simultaneously
        this.pixelsBetweenBullets = 5;

        this.temperature = 0; // currently ready to shoot?
    }

    tick() {
        this.temperature--;
    }

    shoot() {
        if (this.temperature <= 0) {
            this.temperature = this.framesPerBullet;
            let dx = -( (this.numberOfBullets - 1) / 2) * this.pixelsBetweenBullets;
            const objects = this.owner.game.gameObjects;
            for (let i = 0; i < this.numberOfBullets; i++) {
                objects.push(new Bullet(this.owner, this.owner.x + this.owner.w/2 - 2 + dx, this.owner.y, 0, 10 * this.owner.facing))
                dx += this.pixelsBetweenBullets;
            }
        }
    }
}

class Entity extends GameObject {
    constructor(game, x, y, w, h, vx, vy, spr) {
        super(game, x, y, w, h, vx, vy, spr);
        this.weapon = null;
        this.shooting = false;
    }

    tick() {
        super.tick();
        if (this.weapon)
            this.weapon.tick();
        if (this.shooting)
            this.shoot();
    }

    shoot() {
        if (this.weapon)
            this.weapon.shoot();
    }

}

class Enemy extends Entity {
    constructor(game) {
        const w = 35, h = 35;
        super(game, Math.random() * (SCREEN_WIDTH - w), -h, w, h, 0, 5, sprites['enemy1']);
        this.weapon = new PeaShooter(this);
    }

    tick() {
        super.tick();
        this.shooting = Math.random() < 0.01;
    }
}

class Player extends Entity {
    constructor(game) {
        super(game, SCREEN_WIDTH / 2, SCREEN_HEIGHT / 2, 41, 47, 0, 0, sprites['ship']);
        this.friction = SPACE_FRICTION;
        this.weapon = new PeaShooter(this);
        this.facing = -1; // upward
    }

    tick() {
        super.tick();
        if (this.x < 0)
            this.x = 0;
        if (this.x > SCREEN_WIDTH - this.w)
            this.x = SCREEN_WIDTH - this.w;
        if (this.y < 0)
            this.y = 0;
        if (this.y > SCREEN_HEIGHT - this.h)
            this.y = SCREEN_HEIGHT - this.h;
    }
}

class Game {

    constructor() {
        this.player = new Player(this);
        this.gameObjects = [this.player];
        this.enemies = [];
        this.numberOfEnemies = 0;
    }

    start() {
        this.frame();
    }

    tick() {
        // Update game objects
        this.gameObjects.forEach(o => o.tick());

        // Filter out objects marked for removal
        this.gameObjects = this.gameObjects.filter(e => !e.remove);
        this.enemies = this.enemies.filter(e => !e.remove);
        if (this.player && this.player.remove)
            this.player = undefined;

        // Spawn new enemies
        const chance = Math.max(0, 4 - this.numberOfEnemies) * 0.01;
        if (Math.random() < chance) {
            this.add(new Enemy(this));
        }

    }

    add(obj) {
        this.gameObjects.push(obj);
        if (obj instanceof Enemy) {
            this.enemies.push(obj);
        }
    }

    draw() {
        ctx.clearRect(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT);
        this.gameObjects.forEach(o => o.draw());
    }

    processInput() {
        if (!this.player)
            return;
        // Arrows
        if (keyState[KEY_LEFT])
            this.player.vx--;
        else if (keyState[KEY_RIGHT])
            this.player.vx++;
        if (keyState[KEY_UP])
            this.player.vy--;
        else if (keyState[KEY_DOWN])
            this.player.vy++;

        // Shooting
        this.player.shooting = keyState[KEY_SPACE];
    }

    frame(timestamp) {
        if (this.previousTimeStamp === undefined)
            this.previousTimeStamp = timestamp - 1000.0 / 60.0;
        let elapsed = timestamp - this.previousTimeStamp;
        this.previousTimeStamp = timestamp;
        
        while (elapsed > 16) {
            elapsed -= 16;
            this.processInput();
            this.tick();
        }
        this.draw();
        requestAnimationFrame(this.frame.bind(this));
    }
}


document.addEventListener('DOMContentLoaded', async () => {
    // Setup canvas
    const canvas = document.getElementById('game');
    ctx = canvas.getContext('2d');

    // Load sprites
    sprites['ship'] = await loadImage('ship.png');
    sprites['bullet'] = await loadImage('bullet.png');
    sprites['enemy1'] = await loadImage('enemy1.png');
    sprites['enemy2'] = await loadImage('enemy2.png');
    sprites['enemy3'] = await loadImage('enemy3.png');

    // Setup key capturing
    document.addEventListener('keydown', (e) => handleKey(e.key, true));
    document.addEventListener('keyup', (e) => handleKey(e.key, false));

    // Start game
    const game = new Game();
    game.start();
});

        </script>
    </body>
</html>
